Status: Closed Start date: 2009-11-23
Priority: Normal Due date:
Category: Issues Estimated time: 0.00 hour
Description

This patch adds an option which will automatically update an issue's done ratio based on which issue status is assigned.  It's an
optional setting (default off) in the Admin > Settings > Issue Tracking tab.

This is ready to commit pending code review.

issue-status-for-percent-done.png

Designed and sponsored by Shane and Peter Inc.

Related issues:
Related to Redmine - Feature # 952: Update % to be programatic not arbitrary New 2008-03-29
Related to Redmine - Feature # 2561: Correlate workflow with Issue complete p... New 2009-01-22
Related to Redmine - Feature # 4015: Make app settings overridable at project... New 2009-10-10
Duplicated by Redmine - Feature # 5079: Link a completed percentage to an iss... Closed 2010-03-15

Associated revisions
Revision 3151 - 2009-12-11 19:48 - Eric Davis

Adds a Setting to control how an Issue's done_ratio is calculated:

    -  Issue field (default) - the done_ratio field for the Issue
    -  Issue status - uses the Issue Status's value
#4274

History
#1 - 2009-11-27 22:49 - Jean-Philippe Lang
I think there could be a setting for percent done management:
    -  manual (current behaviour)
    -  issue status (this ticket)
    -  spent hours vs. estimate (#952)

With #4015, it could be a per project setting.

#2 - 2009-12-02 01:24 - Eric Davis

I could covert this feature's setting (issue_status_for_done_ratio) from a boolean to a select field.  Then when #952 is implemented, it could become
the third option.
#3 - 2009-12-02 03:14 - Shane Pearlman

I'm a fan of Jean-Phillipe's suggestion. The project level override is extremely important for the way we use this feature.

#4 - 2009-12-11 19:42 - Eric Davis
- Status changed from 7 to Closed
- Target version set to 0.9.0
- % Done changed from 0 to 100

I changed the setting to use a list of options and committed this in r3151.  #952 should be easy for someone to implement.

#5 - 2009-12-14 15:33 - Nanda P
- File RedMine_IssueStatuses.jpg added

Eric,

I pulled trunk version (Redmine 0.8.7.devel.3171 (MySQL))

I couldn't see the % Done option.  I checked the datatabase, I can see the new field "default_done_ratio" in issue_statuses table with NULL.

RedMine_IssueStatuses.jpg

Is there any settings to enable this option?

Regards,
Nanda

#6 - 2009-12-14 15:37 - Felix Schäfer

Nanda Palaniswamy wrote:

Is there any settings to enable this option?

You have to click on each status, and in the status configuration, you have a list from which you can choose what percent done corresponds to this
status.

#7 - 2009-12-14 15:58 - Nanda P
- File RedMine_IssueStatuses_1.jpg added

Felix,

Thanks for your response.

When I click a status to update it, I don't see the "Percent Done" field..
here is a screen shot.

RedMine_IssueStatuses_1.jpg

#8 - 2009-12-14 23:23 - Nicklas Holm

Nanda Palaniswamy wrote:

Felix,

Thanks for your response.

When I click a status to update it, I don't see the "Percent Done" field..

here is a screen shot.

RedMine_IssueStatuses_1.jpg

You will have to go to the "Issue tracking" tab in the admin settings and set "Calculate the issue done ratio with" to "Use the issue status". Now you will
have an extra field.

#9 - 2009-12-15 01:08 - Mischa The Evil

Also note that when "Calculate the issue done ratio with" is set to "Use the issue status" any user is not able any longer to update the issue done ratio
manually since the field isn't displayed on issue new/edit forms. The ratio is strictly set automatically depending on the issue status.

Off-topic: I must admit I really like the way how Eric has implemented this feature... Though it's a personal preference...

#10 - 2009-12-15 02:03 - Nanda P

Nicklas Holm wrote:

Nanda Palaniswamy wrote:

Felix,

Thanks for your response.

When I click a status to update it, I don't see the "Percent Done" field..

here is a screen shot.

RedMine_IssueStatuses_1.jpg

You will have to go to the "Issue tracking" tab in the admin settings and set "Calculate the issue done ratio with" to "Use the issue status". Now you
will have an extra field.

Nicklas:
After setting "Use the issue status" it working like a charm!!

Thanks a Lot :)

#11 - 2009-12-25 15:51 - Alexey Palazhchenko

I think it will be nice to implement mixed behavior. For example, I want "New" status be fixed to 0% and "Resolved" status to 100%, but I want to have
a possibility to specify percentage for "In progress" status. Should I extract this feature request into new ticket?

#12 - 2010-04-13 17:42 - Bruno Medeiros

Good idea, Aleksey!
Avoid user to set manually the status is not needed to this feature to work.

#13 - 2010-05-19 16:10 - Tharuka Pathirana

Leaving the "% Done" for a status empty: Does it mean it doesn't change regardless what the percentage was before the status change or does it
mean that the percentage is set to empty?
Unfortunately there is no information about this in the wiki yet.

#14 - 2010-05-19 17:18 - Felix Schäfer

Try it out and amend the wiki :-)

#15 - 2010-05-19 19:17 - Tharuka Pathirana

Well, I did... ;)
[[RedmineSettings#Calculate-the-issue-done-ratio|Here]] and [[RedmineIssueTrackingSetup#Issue-statuses|here]].

#16 - 2010-05-24 22:37 - Mischa The Evil

Tharuka Pathirana wrote:

Well, I did... ;)

[[RedmineSettings#Calculate-the-issue-done-ratio|Here]] and [[RedmineIssueTrackingSetup#Issue-statuses|here]].

Thanks for your help... :)

#17 - 2010-11-30 17:49 - Chuck H

I am running RedMine v1.0.2 on a Windows server and I would like to implement this patch but I have no idea how.  Can someone please point me to
some documentation on how to implement this patch file.
#18 - 2012-11-22 21:30 - Thomas Robbs

I want to use this setting, but I have to reluctantly because it affects all projects.

Can this be "fixed", such that it can be implemented at the project, tracker, [other?] levels setting vs. just at the  application level settings?

See also #4015.

#19 - 2012-11-25 08:09 - Toshi MARUYAMA
- Assignee deleted (Eric Davis)

#20 - 2012-11-25 08:10 - Toshi MARUYAMA
- Assignee set to Eric Davis

#21 - 2018-03-19 05:35 - Uuganbayar Battulga

Hi Jean-Philippe Lang,
This is a very useful thing, it can not be inserted into redmine core system

#22 - 2018-03-19 06:22 - Bernhard Rohloff

Uuganbayar Battulga wrote:

Hi Jean-Philippe Lang,
This is a very useful thing, it can not be inserted into redmine core system

What exactly would you like to see in Redmine? This particular feature was integrated 8 years ago so it is part of Redmine's core system already.
